//Head n Shoulders trail
datablock ParticleData(HSTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 600;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/ring";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "0.8 0.8 0.8 0.2";
	colors[1]	= "0.75 0.75 0.75 0.1";
	colors[2]	= "1 1 1 0.0";
	sizes[0]	= 0.15;
	sizes[1]	= 0.35;
	sizes[2]	= 0.05;
	times[0]	= 0.0;
	times[1]	= 0.1;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(HSTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = HSTrailParticle;

   useEmitterColors = true;
   uiName = "Head n Shoulders Trail";
};


//effects
datablock ParticleData(HSExplosionParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.5;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 900;
	lifetimeVarianceMS	= 300;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
	colors[0]	= "0.8 0.8 0.8 0.5";
	colors[1]	= "0.6 0.6 0.6 0.0";
	sizes[0]	= 1.0;
	sizes[1]	= 2.0;
	times[0]	= 0.0;
	times[1]	= 1;
};

datablock ParticleEmitterData(HSExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   lifeTimeMS	   = 15;
   ejectionVelocity = 4;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "HSExplosionParticle";

   uiName = "Head n Shouders Smoke";
   emitterNode = TenthEmitterNode;
};

datablock ParticleData(HSExplosionParticle2)
{
	dragCoefficient		= 0.1;
	windCoefficient		= 0.0;
	gravityCoefficient	= 2.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 1200;
	lifetimeVarianceMS	= 200;
	spinSpeed		= 6.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/chunk";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
	colors[0]	= "0.85 0.7 0.4 1.0";
	colors[1]	= "0.85 0.7 0.4 0.2";
	sizes[0]	= 0.7;
	sizes[1]	= 0.8;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(HSExplosionEmitter2)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 1;
   lifetimeMS       = 25;
   ejectionVelocity = 4;
   velocityVariance = 1.5;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "HSExplosionParticle2";

   useEmitterColors = true;
   uiName = "Head n Shoulders Shampoo 1";
   emitterNode = HalfEmitterNode;
};

datablock ParticleEmitterData(HSExplosionEmitter3)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   lifetimeMS       = 10;
   ejectionVelocity = 8;
   velocityVariance = 1;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "HSExplosionParticle2";

   useEmitterColors = true;
   uiName = "Head n Shoulders Shampoo 2";
   emitterNode = HalfEmitterNode;
};

datablock ExplosionData(HSExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 150;

   soundProfile = spearExplosionSound;

   emitter[0] = HSExplosionEmitter;
   emitter[1] = HSExplosionEmitter2;
   emitter[2] = HSExplosionEmitter3;
   //particleDensity = 30;
   //particleRadius = 1.0;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "8.0 9.5 8.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 4;
   lightEndRadius = 3;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 3.5;
   impulseForce = 2000;

   //radius damage
   radiusDamage        = 40;
   damageRadius        = 3.5;
};

//projectile
AddDamageType("HSDirect",   '<bitmap:add-ons/Weapon_HS/CI_HS> %1',       '%2 <bitmap:add-ons/Weapon_HS/CI_HS> %1',1,1);
AddDamageType("HSRadius",   '<bitmap:add-ons/Weapon_HS/CI_HSRadius> %1', '%2 <bitmap:add-ons/Weapon_HS/CI_HS> %1',1,0);
datablock ProjectileData(HSProjectile)
{
   projectileShapeName = "./HSProjectile.dts";
   directDamage        = 30;
   directDamageType  = $DamageType::HSDirect;
   radiusDamageType  = $DamageType::HSRadius;
   impactImpulse	   = 280;
   verticalImpulse	   = 280;
   explosion           = HSExplosion;
   particleEmitter     = HSTrailEmitter;

   brickExplosionRadius = 0.3;
   brickExplosionImpact = true; //destroy a brick if we hit it directly?
   brickExplosionForce  = 5;
   brickExplosionMaxVolume = 2;
   brickExplosionMaxVolumeFloating = 4;

   muzzleVelocity      = 25;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 17500;
   fadeDelay           = 16000;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0.65;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Head n Shoulders";
 };


//////////
// item //
//////////
datablock ItemData(HSItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./HS.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Head n Shoulders";
	iconName = "./icon_HS";
	doColorShift = true;
	colorShiftColor = "0.850 0.850 0.850 1.000";

	 // Dynamic properties defined by the scripts
	image = HSImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(HSImage)
{
   // Basic Item properties
   shapeFile = "./HS.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = HSItem;
   ammo = " ";
   projectile = HSProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = HSItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= true;
	
	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]	= "Armed";
	stateTimeoutValue[2]            = 0.7;
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortCharge";
	stateScript[2]                  = "onCharge";
	stateAllowImageChange[2]        = false;
	
	stateName[3]			= "AbortCharge";
	stateTransitionOnTimeout[3]	= "Ready";
	stateTimeoutValue[3]		= 0.3;
	stateWaitForTimeout[3]		= true;
	stateScript[3]			= "onAbortCharge";
	stateAllowImageChange[3]	= false;

	stateName[4]			= "Armed";
	stateTransitionOnTriggerUp[4]	= "Fire";
	stateAllowImageChange[4]	= false;

	stateName[5]			= "Fire";
	stateTransitionOnTimeout[5]	= "Ready";
	stateTimeoutValue[5]		= 0.5;
	stateFire[5]			= true;
	stateSequence[5]		= "fire";
	stateScript[5]			= "onFire";
	stateWaitForTimeout[5]		= true;
	stateAllowImageChange[5]	= false;
	stateSound[5]				= spearFireSound;
};

function HSImage::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2, spearReady);
}

function HSImage::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}

function HSImage::onFire(%this, %obj, %slot)
{
	%obj.playthread(2, spearThrow);
	Parent::onFire(%this, %obj, %slot);
}